--- linux-4.11/arch/arm/boot/Makefile.orig	2013-09-03 12:34:43.072308344 +0200
+++ linux-4.11/arch/arm/boot/Makefile	2015-03-17 12:36:06.504042116 +0200
@@ -52,8 +52,13 @@
 $(obj)/compressed/vmlinux: $(obj)/Image FORCE
 	$(Q)$(MAKE) $(build)=$(obj)/compressed $@
 
-$(obj)/zImage:	$(obj)/compressed/vmlinux FORCE
-	$(call if_changed,objcopy)
+dtbfile := $(shell echo $(CONFIG_ARM_APPENDED_DTB_FILE))
+quiet_cmd_append = APPEND  $(dtbfile)  $@
+      cmd_append = (cat /dev/null $(dtbfile) >> $@)
+
+$(obj)/zImage: $(obj)/compressed/vmlinux $(dtbfile) FORCE
+	$(call if_changed,objcopy)
+	$(call if_changed,append)
 
 endif
 
--- linux-4.11/arch/arm/Kconfig.orig	2013-09-02 22:46:10.000000000 +0200
+++ linux-4.11/arch/arm/Kconfig	2015-03-17 12:36:06.504042116 +0200
@@ -1929,6 +1929,16 @@
 	  location into r2 of a bootloader provided DTB is always preferable
 	  to this option.
 
+config ARM_APPENDED_DTB_FILE
+	string "DTB file"
+	depends on ARM_APPENDED_DTB
+	default ""
+	help
+	  This gives the name of file from the build directory to append
+	  to the zImage after it has been built.
+
+	  If you are not sure, leave it blank.
+
 config ARM_ATAG_DTB_COMPAT
 	bool "Supplement the appended DTB with traditional ATAG information"
 	depends on ARM_APPENDED_DTB
